let closeQrocdeBlk

$(function () {
    var _count_pos = 0,
        count_act = false
    var checkScrollAndTrigger = function (e) {
        if(document.querySelector('.count')){
        _count_pos = document.querySelector('.count').getBoundingClientRect()
            if (!count_act && _count_pos.y < window.innerHeight - 150) {
                count_act = true
                $('.count').each(function () {
                    $(this)
                        .prop('Counter', 0)
                        .animate(
                            {
                                Counter: $(this).text(),
                            },
                            {
                                duration: 3000,
                                easing: 'swing',
                                step: function (now) {
                                    $(this).text(Math.ceil(now))
                                },
                            }
                        )
                })
            }
        }
    }
    setTimeout(() => {
        $(window).scroll(checkScrollAndTrigger)
        checkScrollAndTrigger()
    }, 4250)
})

// QRcode blk
let cT,
    valAppUrlString = ''
let _openApp = document.querySelector('.open-app')
let _qrcode_blk = document.querySelector('.center-block')
let _timer = document.querySelector('.timer-div')
let _totalSeconds = 30
let totalSeconds = _totalSeconds
let isMobile =
    window.getComputedStyle(document.querySelector('.open-app'), null).getPropertyValue('display') == 'block'
        ? true
        : false

let _icon = document.createElement('img')
_icon.src = 'assets/images/ctbcbankQRcode/safe_site_qrcode.svg'

let _err_pic = document.createElement('img')
_err_pic.src = 'assets/images/ctbcbankQRcode/error_02.png'

let pad = function (val) {
    var valString = val + ''
    if (valString.length < 2) {
        return '0' + valString
    } else {
        return valString
    }
}

let setTime = function () {
    if (totalSeconds > 0) {
        --totalSeconds
        _timer.style.color = ''
        _timer.innerHTML = pad(parseInt(totalSeconds / 60)) + ':' + pad(totalSeconds % 60)
    } else {
        _timer.style.color = '#f00'
        if (!isMobile) {
            _qrcode_blk.innerHTML = ''
            _qrcode_blk.appendChild(_err_pic)
            _warnTxt = document.createElement('p')
            _warnTxt.innerHTML = 'QR Code已逾時，請重新產生'
            _warnTxt.style.fontSize = '0.9rem'
            _qrcode_blk.appendChild(_warnTxt)
        }
        _openApp.disabled = true
        _openApp.setAttribute('disabled', 'disabled')
        _openApp.innerHTML = '請重新產生，進行驗證'

        clearInterval(cT)
    }
}

let openQrocdeBlk = function () {
    clearInterval(cT)
    totalSeconds = _totalSeconds
    setTime()
    cT = setInterval(setTime, 1000)

    _qrcode_blk.innerHTML = ''
    _openApp.disabled = false
    _openApp.removeAttribute('disabled')
    _openApp.innerHTML = '開啟 APP 驗證'

    try {
        let valQRCodeString = ''
        EBMW.init('https://www.ctbcbank.com'); //  2023.10 因MKT網域加上判斷
        let data = EBMW.preLogin('/twrbc-general/ot048/010', {})
        data.done((data) => {
            //  如果是小版點擊時要開啟這個連結
            valAppUrlString = data.rsData.openHomeBankAppUrl

            //大版顯示這個
            valQRCodeString = data.rsData.codeText
            $('.center-block').empty()
            // $('.center-block').qrcode(valQRCodeString);
            $('.center-block').qrcode({
                // render method: 'canvas', 'image' or 'div'
                render: 'canvas',

                // error correction level: 'L', 'M', 'Q' or 'H'
                ecLevel: 'H',

                // size in pixel
                size: 200,

                // code color or image element
                fill: '#000',

                // content
                text: valQRCodeString,

                // corner radius relative to module width: 0.0 .. 0.5
                radius: 0,

                // quiet zone in modules
                quiet: 0,

                // modes
                // 0: normal
                // 1: label strip
                // 2: label box
                // 3: image strip
                // 4: image box
                mode: 4,

                mSize: 0.2,
                mPosX: 0.5,
                mPosY: 0.5,

                label: 'no label',
                fontname: 'sans',
                fontcolor: '#000',

                image: _icon,
            })
        })
    } catch (e) {
        console.log(e)
    }
}

let _q = document.querySelector('[data-qrcode-validate]')

closeQrocdeBlk = function () {
    if (_q) {
        _q.click()
    }
}

if (_q) {
    document.querySelector('.link-refresh').addEventListener('click', function () {
        openQrocdeBlk()
    })

    _openApp.addEventListener('click', function (e) {
        console.log(valAppUrlString)
        window.open(valAppUrlString)
    })

    _q.addEventListener('click', function (e) {
        let _qiw = document.querySelector('#qrcode_verify')

        if (!e.currentTarget.classList.contains('qrcode_loaded')) {
            _qiw.classList.remove('d-none')

            openQrocdeBlk()

            openNav()

            document.querySelector('body').style.overflow = 'hidden'
        } else {
            _qiw.classList.add('d-none')

            closeNav()

            document.querySelector('body').style.overflow = 'auto'
        }

        e.currentTarget.classList.toggle('qrcode_loaded')
    })

    setTime()
}

// overlay
function openNav() {
    document.getElementById('overlayMask').style.backgroundColor = 'rgba(0,0,0,0.8)'
    document.getElementById('overlayMask').style.display = 'block'
    document.body.style.overflow = 'hidden'
}

function closeNav() {
    document.getElementById('overlayMask').style.backgroundColor = 'rgba(0,0,0,0)'
    document.getElementById('overlayMask').style.display = 'none'
    document.body.style.overflow = 'auto'
}
